
Rm Rmi = r_front;
volatile u16 Key_time[4];
volatile u8  Time_index = 0;
volatile u8  Key_state;
volatile u8  Key_index;
volatile u16 icr_tmp_4;
u8 Key_pow = 0;
const u16 time_shift = 1300;

extern "C"
{
 #pragma diag_suppress = Pa082

 #pragma vector = TIMER1_CAPT_vect
 __interrupt void t1_cpt (void)
 {
  const u16 min_capt_val = CPU_FRQ/65;
  const u16 max_capt_val = CPU_FRQ/45;
  const u8 a_table[10]= {
                         (u16)      37*256/180, //10%
                         (u16)      53*256/180, //20%
                         (u16)      66*256/180, //30% 93
                         (u16)      78*256/180, //40%
                         (u16)      90*256/180, //50%
                         (u16)(180-78)*256/180, //60%
                         (u16)(180-66)*256/180, //70%
                         (u16)(180-53)*256/180, //80%
                         (u16)(180-37)*256/180, //90%
                         (u16)0xff              //100%
                        };
  const u8 b_table[10]= {
                         (u16)      26*256/90 , //10%
                         (u16)      37*256/90 , //20%
                         (u16)      46*256/90 , //30%
                         (u16)      53*256/90 , //40%
                         (u16)      60*256/90 , //50%
                         (u16)      66*256/90 , //60%
                         (u16)      73*256/90 , //70%
                         (u16)      78*256/90 , //80%
                         (u16)      84*256/90 , //90%
                         (u16)0xff              //100%
                        };

  static u16 icr_tmp;
  static u16 icr_tmp_2;
  static u16 icr_tmp_8;
  static u16 icr_agl;
  static u8  i;

  if(ICR1 < min_capt_val || ICR1 > max_capt_val) goto t1_cpt_exit;

  // 
  TCNT1 = 0;

  PORTB_Bit7 ^= 1;

  icr_tmp   = ICR1;
  icr_tmp_2 = icr_tmp   >>1;
  icr_tmp_4 = icr_tmp_2 >>1;
  icr_tmp_8 = icr_tmp_4 >>1;

  Key_index  = 0;
  Time_index = 0;

  switch(Rmi)
  {
   case r_wmiss:
   {
    const u8 pow_table[10][2] = {
                                 {0,1 }, // 0%
                                 {1,5 }, //20%
                                 {1,3 }, //30%
                                 {2,5 }, //40%
                                 {1,2 }, //50% *
                                 {3,5 }, //60%
                                 {5,7 }, //71%
                                 {4,5 }, //80% *
                                 {9,10}, //90% *
                                 {1,1 }  //100%
                                };
    static u8 ccnt_on;
    static u8 ccnt_all;
    static bool trg;

    if(!ccnt_all)
    {
     ccnt_on  = pow_table[Key_pow][0];
     ccnt_all = pow_table[Key_pow][1];

     trg = false;
    }

    ccnt_all--;

    //       
    if(ccnt_on)
    {
     ccnt_on--;

     //      
     if(trg == false) {Key_state = bin(00111111); trg = true;}
     else              Key_state = bin(11111111);
    }
    else
    {
     if(trg == true)  {Key_state = bin(11000000); trg = false;}
     else              Key_state = 0;
    }

    for(i = 0; i < 4; i++) Key_time[i] = icr_tmp_8 + icr_tmp_4*i - time_shift;
   }
   break;

   case r_front:
   {
    if(Key_pow == MAX_POW/2)
    {
     Key_state = bin(11011101);

     Key_time[0] = icr_tmp_8             - time_shift;
     Key_time[1] = icr_tmp_2             - time_shift;
     Key_time[2] = icr_tmp_2 + icr_tmp_8 - time_shift;
     Key_time[3] = icr_tmp               - time_shift;
    }
    else
    {
     icr_agl = ((u32)icr_tmp_2 * a_table[Key_pow]>>8);

     if(Key_pow > MAX_POW/2)
     {
      Key_state = bin(11011101);

      Key_time[0] = icr_tmp_8                       - time_shift;
      Key_time[1] = icr_tmp_4 + icr_tmp_2 - icr_agl - time_shift;
      Key_time[2] = icr_tmp_2 + icr_tmp_8           - time_shift;
      Key_time[3] = icr_tmp   + icr_tmp_4 - icr_agl - time_shift;
     }
     //             
     else if (icr_agl > icr_tmp_4 - time_shift)
     {
      Key_state = bin(11000100);

      Key_time[0] = icr_tmp_4 - icr_tmp_8           - time_shift;
      Key_time[1] = icr_tmp_4 + icr_tmp_8           - time_shift;
      Key_time[2] = icr_tmp_2 + icr_tmp_4 - icr_agl - time_shift;
      Key_time[3] = icr_tmp   - icr_tmp_8           - time_shift;
     }
     else
     {
      Key_state = bin(01000100);

      Key_time[0] = icr_tmp_4 - icr_agl             - time_shift;
      Key_time[1] = icr_tmp_4 + icr_tmp_8           - time_shift;
      Key_time[2] = icr_tmp_2 + icr_tmp_4 - icr_agl - time_shift;
      Key_time[3] = icr_tmp   - icr_tmp_8           - time_shift;
     }
    }
   }
   break;

   case r_spad:
   {
    if(Key_pow == MAX_POW/2)
    {
     Key_state = bin(00110010);

     Key_time[0] = icr_tmp_8             - time_shift;
     Key_time[1] = icr_tmp_4 + icr_tmp_8 - time_shift;
     Key_time[2] = icr_tmp_2 + icr_tmp_8 - time_shift;
     Key_time[3] = icr_tmp               - time_shift;
    }
    else
    {
     icr_agl = ((u32)icr_tmp_2 * a_table[Key_pow]>>8);

     if(Key_pow < MAX_POW/2)
     {
      Key_state = bin(00100010);

      Key_time[0] = icr_tmp_8                       - time_shift;
      Key_time[1] = icr_tmp_4 +             icr_agl - time_shift;
      Key_time[2] = icr_tmp_2 + icr_tmp_8                       ;
      Key_time[3] = icr_tmp_2 + icr_tmp_4 + icr_agl - time_shift;
     }
     //         
     else
     {
      if(icr_agl < icr_tmp_4 + time_shift)
      {
       Key_state = bin(00111010);

       Key_time[0] = icr_tmp_8                       - time_shift;
       Key_time[1] = icr_tmp_4 + icr_tmp_8           - time_shift;
       Key_time[2] = icr_tmp_4 + icr_agl             - time_shift;
       Key_time[3] = icr_tmp_2 + icr_tmp_4 + icr_agl - time_shift;
      }
      //       
      else
      {
       Key_state = bin(10111011);

       Key_time[0] = icr_tmp_4 - (icr_tmp_2 - icr_agl) - time_shift;
       Key_time[1] = icr_tmp_4 + icr_tmp_8                         ;
       Key_time[2] = icr_tmp_4 + icr_agl               - time_shift;
       Key_time[3] = icr_tmp   - icr_tmp_8                         ;
      }
     }
    }
   }
   break;

   case r_frspd:
   {
    icr_agl = ((u32)icr_tmp_4 * b_table[Key_pow]>>8);

    if(icr_tmp_4 - time_shift > icr_agl)
    {
     Key_state = bin(01100110);

     Key_time[0] = icr_tmp_4 - icr_agl             - time_shift;
     Key_time[1] = icr_tmp_4 + icr_agl             - time_shift;
     Key_time[2] = icr_tmp_2 + icr_tmp_4 - icr_agl - time_shift;
     Key_time[3] = icr_tmp_2 + icr_tmp_4 + icr_agl - time_shift;
    }
    else
    {
     Key_state = bin(11100110);

     Key_time[0] = icr_tmp_4 - icr_tmp_8           - time_shift;
     Key_time[1] = icr_tmp_4 + icr_agl             - time_shift;
     Key_time[2] = icr_tmp_2 + icr_tmp_4 - icr_agl - time_shift;
     Key_time[3] = icr_tmp_2 + icr_tmp_4 + icr_agl - time_shift;
    }
   }
   break;

   default: break;
  }

  if(Rmi < r_nosinch)
  {
   MOS_CONTROL = !(Key_state & (u8)0x80);
   OCR1A = icr_tmp_4 - time_shift;

   if(Key_time[0] < TCNT1 + 50) Key_time[0] = TCNT1 + 50;

   OCR1B = Key_time[0];

   TIMSK = 1<<TOIE1 | 1<<TICIE1 | 1<<OCIE1A | 1<<OCIE1B;

   Time_index++;
   Key_index++;
  }
  else TIMSK = 1<<TOIE1 | 1<<TICIE1;

  TIFR = 1<<TOV1 | 1<<OCF1A | 1<<OCF1B;

  t1_cpt_exit: __no_operation();
 }

 //        
 #pragma vector = TIMER1_COMPA_vect
 __interrupt void t1_cmpa (void)
 {
  if(Time_index < 4)
  {
   //        
   OCR1A += icr_tmp_4;

   MOS_CONTROL = !(Key_state & ((u8)0x80>>Key_index));
   OCR1B = Key_time[Time_index];

   Time_index++;
   Key_index++;
  }
 }

 #pragma vector = TIMER1_COMPB_vect
 __interrupt void t1_cmpb (void)
 {
  MOS_CONTROL = !(Key_state & ((u8)0x80>>Key_index));

  Key_index++;
 }

 #pragma vector = TIMER1_OVF_vect
 __interrupt void t1_ovf (void)
 {
  TIMSK = 1<<TOIE1 | 1<<TICIE1;

  T1_ovf = true;
 }

 #pragma diag_default = Pa082
}


/*
#define    RESET_vect           (0x00)
#define    INT0_vect            (0x02)
#define    INT1_vect            (0x04)
#define    TIMER2_COMP_vect     (0x06)
#define    TIMER2_OVF_vect      (0x08)
#define    TIMER1_CAPT_vect     (0x0A)
#define    TIMER1_COMPA_vect    (0x0C)
#define    TIMER1_COMPB_vect    (0x0E)
#define    TIMER1_OVF_vect      (0x10)
#define    TIMER0_OVF_vect      (0x12)
#define    SPI_STC_vect         (0x14)
#define    USART_RXC_vect       (0x16)
#define    USART_UDRE_vect      (0x18)
#define    USART_TXC_vect       (0x1A)
#define    ADC_vect             (0x1C)
#define    EE_RDY_vect          (0x1E)
#define    ANA_COMP_vect        (0x20)
#define    TWI_vect             (0x22)
#define    SPM_RDY_vect         (0x24)
*/